function [ acc ] = evaluate_triclustering( z, z_ref )
% z, z_ref: int P x 1

    assert(size(z, 1) == size(z_ref, 1));
    assert(max(z_ref) == 3);
    n = size(z, 1);
    
    acc = 0;
    K = max(max(z), 3);
    
    for i = 1:K
        for j = 1:K
            for k = 1:K
                if ((i ~= j) && (i ~= k) && (j ~= k))
                    zt = zeros(n, 1);
                    zt = zt + 1 * (z == i * ones(n, 1));
                    zt = zt + 2 * (z == j * ones(n, 1));
                    zt = zt + 3 * (z == k * ones(n, 1));
                    t = mean(zt == z_ref);
                    if (t > acc)
                        acc = t;
                    end
                end
            end
        end
    end

end

