% validate1_dpmeans

n = 100000;
m = 10000;
D = 10;
T = 10;
maxK = 30;
maxT = 50;
eps = 1e-3;

zT4 = zeros(T, n);
muT4 = zeros(T, maxK, D);
KT4 = zeros(T, 1);
nmiT4 = zeros(T, 1);
rT4 = zeros(T, 1);
lambdaT4 = zeros(T, 1);

lambdas = [1 2.5 5 10 25 50 100 250 500 1000];

for t = 1:T
    
    x0 = squeeze(x(t, :, :));
    z0 = squeeze(z(t, :))';
    
    % parameter selection
    ls = size(lambdas, 2);
    result = zeros(1, ls);
    for i = 1:ls
        [z4, K4] = dpmeans(x0(1:m, :), lambdas(i), maxK, maxT, eps, 1);
        result(i) = compute_nmi(z4, z0(1:m));
        if (K4 > 10)
            result(i) = -1e100;
        end
    end
    [max_value, lambda_id] = max(result);
    lambda = lambdas(lambda_id);
    lambdaT4(t) = lambda;
    disp(lambda);
    
    % real clustering
    tt = cputime;
    [z4, mu4, K4] = dpmeans(x0, lambda, maxK, maxT, eps, 0);
    rT4(t) = cputime - tt;
    zT4(t, :) = z4;
    muT4(t, :, :) = mu4;
    KT4(t) = K4;
    nmiT4(t) = compute_nmi(z4, z0);
    fprintf('K4 = %d, nmi = %f\n', K4, nmiT4(t));
    
end