% validate1_mppca

n = 100000;
K = 6;
T = 10;
maxT = 50;
eps = 1e-3;
D = 10;

d = 4 * ones(K, 1);

zT3 = zeros(T, n);
PiT3 = zeros(T, K);
WT3 = zeros(T, K, D, D);
muT3 = zeros(T, K, D);
sigmasqT3 = zeros(T, K);
rT3 = zeros(T, 1);
nmiT3 = zeros(T, 1);

for t = 1:T
    
%t = 7;

    fprintf('Round %d ...\n', t);
    
    x0 = squeeze(x(t, :, :));
    z0 = squeeze(z(t, :))';
    
    tt = cputime;
    [z3, Pi3, W3, mu3, sigmasq3] = em_mppca(x0, K, d, maxT, eps);
    rT3(t) = cputime - tt;
    
    zT3(t, :) = z3';
    PiT3(t, :) = Pi3';
    WT3(t, :, :, :) = W3;
    muT3(t, :, :) = mu3;
    sigmasqT3(t, :) = sigmasq3;
    
    nmiT3(t) = compute_nmi(z3, z0);
    
    disp(nmiT3(t));
    
end